class IS_TAB extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x200;
        this.Mnemonic = "TAB";
        this.LongName = "TRANSFER Register A to B";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_AL | CONTROL_RBIL;
    }
}

is_TAB = new IS_TAB;
Instructions.push(is_TAB);

class IS_TAC extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x201;
        this.Mnemonic = "TAC";
        this.LongName = "TRANSFER Register A to C";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_AL | CONTROL_RCIL;
    }
}

is_TAC = new IS_TAC;
Instructions.push(is_TAC);

class IS_TAD extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x202;
        this.Mnemonic = "TAD";
        this.LongName = "TRANSFER Register A to D";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_AL | CONTROL_RDIL;
    }
}

is_TAD = new IS_TAD;
Instructions.push(is_TAD);

class IS_TBA extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x203;
        this.Mnemonic = "TBA";
        this.LongName = "TRANSFER Register B to A";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_BL | CONTROL_RAIL;
    }
}

is_TBA = new IS_TBA;
Instructions.push(is_TBA);

class IS_TBC extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x204;
        this.Mnemonic = "TBC";
        this.LongName = "TRANSFER Register B to C";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_BL | CONTROL_RCIL;
    }
}

is_TBC = new IS_TBC;
Instructions.push(is_TBC);

class IS_TBD extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x205;
        this.Mnemonic = "TBD";
        this.LongName = "TRANSFER Register B to D";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_BL | CONTROL_RDIL;
    }
}

is_TBD = new IS_TBD;
Instructions.push(is_TBD);

class IS_TCA extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x206;
        this.Mnemonic = "TCA";
        this.LongName = "TRANSFER Register C to A";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_CL | CONTROL_RAIL;
    }
}

is_TCA = new IS_TCA;
Instructions.push(is_TCA);

class IS_TCB extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x207;
        this.Mnemonic = "TCB";
        this.LongName = "TRANSFER Register C to B";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_CL | CONTROL_RBIL;
    }
}

is_TCB = new IS_TCB;
Instructions.push(is_TCB);

class IS_TCD extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x208;
        this.Mnemonic = "TCD";
        this.LongName = "TRANSFER Register C to D";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_CL | CONTROL_RDIL;
    }
}

is_TCD = new IS_TCD;
Instructions.push(is_TCD);

class IS_TDA extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x209;
        this.Mnemonic = "TDA";
        this.LongName = "TRANSFER Register D to A";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_DL | CONTROL_RAIL;
    }
}

is_TDA = new IS_TDA;
Instructions.push(is_TDA);

class IS_TDB extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x20A;
        this.Mnemonic = "TDB";
        this.LongName = "TRANSFER Register D to B";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_DL | CONTROL_RBIL;
    }
}

is_TDB = new IS_TDB;
Instructions.push(is_TDB);

class IS_TDC extends Microcode_Instruction {
    constructor(props) {
        super(props);
        this.Bytecode = 0x20B;
        this.Mnemonic = "TDC";
        this.LongName = "TRANSFER Register D to C";
        this.Aliases = new Array();

        this.Type = InstructionTypes.Register;
        this.Operands = new Array();
        this.Words = 1;
        this.Cycles = 3;
        this.Microcode[2] = CONTROL_OUT_DL | CONTROL_RCIL;
    }
}

is_TDC = new IS_TDC;
Instructions.push(is_TDC);

